# $Id: plugin_rules.mk 2559 2008-01-29 15:58:28Z yone $
#-------------------------------------------------------------------------------
# ץ饰ѶMakefile
#
#-------------------------------------------------------------------------------
# ץ饰饤֥ϤMakefile ɬinclude 뤳ȡ
#
# ġMakefile ǽѿ
# ============================================
#	NAME         : ץ饰δ̾ (MUST)
#	SDKDIR       : ץ饰SDKΥȥåץǥ쥯ȥѥ (MUST)
#	(Ĥrules.mk )
#
# ġMakefile Ǻǽʤ륿å
# ============================================
#	INSTALL_TARGETS   : make install Υå (MUST)
#	UNINSTALL_TARGETS : make uninstall Υå (MUST)
#
#-------------------------------------------------------------------------------

# default target
all: all-local

# include common makefile
include $(SDKDIR)/build/rules.mk

#--------------------------------------
# Define values for plugin
#--------------------------------------
PLUGINDIR = $(PLUGINBASEDIR)/$(NAME)
PROGRAM = tfspm_$(NAME).la
STOBJS = $(PROGRAM:.la=.a)
SOOBJS = $(PROGRAM:.la=.so)

ifndef INSTALL_TARGETS
INSTALL_TARGETS = install-plugin
endif

ifndef UNINSTALL_TARGETS
UNINSTALL_TARGETS = uninstall-plugin
endif

#--------------------------------------
# Build target
#--------------------------------------
all-local: x-all $(PROGRAM) conf/plugin.xml

$(PROGRAM): $(OBJS)
	@if test "x$(PLUGINTYPE)" != "xscript"; then \
		$(DLL_LINK) -rpath $(PLUGINDIR) $(LOBJS) ;\
	fi ;

conf/plugin.xml: conf/plugin.xml.in
	@cat $< | sed -e 's:@prefix@:$(SDKDIR):g' > $@

#--------------------------------------
# Install target
#--------------------------------------
install: all $(INSTALL_TARGETS)

install-plugin:
	@if test ! -d $(DESTDIR)$(PLUGINDIR) ; then \
		$(INSTALL) -m 755 -d $(DESTDIR)$(PLUGINDIR) ; \
	fi ; \
	if test ! -d $(DESTDIR)$(PLUGINDIR) ; then \
		$(INSTALL) -m 755 -d $(DESTDIR)$(PLUGINDIR) ; \
	fi ; \
	if test ! -d $(DESTDIR)$(PLUGINDIR)/conf; then \
		$(INSTALL) -m 755 -d $(DESTDIR)$(PLUGINDIR)/conf ; \
	fi ; \
	if test ! -d $(DESTDIR)$(PLUGINDIR)/cgi-bin; then \
		$(INSTALL) -m 755 -d $(DESTDIR)$(PLUGINDIR)/cgi-bin ; \
	fi ; \
	if test ! -d $(DESTDIR)$(PLUGINDIR)/uploads; then \
		$(INSTALL) -m 755 -d $(DESTDIR)$(PLUGINDIR)/uploads ; \
	fi ; \
	if test "x$(PLUGINTYPE)" != "xscript"; then \
		$(LIBTOOL) --mode=install cp $(PROGRAM) $(DESTDIR)$(PLUGINDIR) ; \
		$(RM) -f $(DESTDIR)$(PLUGINDIR)/$(PROGRAM) $(DESTDIR)$(PLUGINDIR)/$(STOBJS) ; \
	fi ; \
	if test ! -f $(DESTDIR)$(PLUGINDIR)/plugin.xml; then \
		$(LIBTOOL) --mode=install cp conf/plugin.xml $(DESTDIR)$(PLUGINDIR) ; \
	fi

#--------------------------------------
# Uninstall library
#--------------------------------------
uninstall: $(UNINSTALL_TARGETS)

uninstall-plugin:
	@$(RM) -f $(DESTDIR)$(PLUGINDIR)/$(SOOBJS) $(DESTDIR)$(PLUGINDIR)/plugin.xml

.PHONY: all all-local \
		install install-plugin uninstall uninstall-plugin

