/**
 * $Id: tfsp_ihdr.h 1387 2006-03-06 02:17:52Z takehara $
 *
 * TeamFileץ饰SDKѥإåե(ץ饰󥤥󥿡եϥɥ)
 * (note)
 *	ƥץ饰ϤΥإåեɬincludeƲ
 */
#ifndef INCLUDE_TFSP_IHDR_H
#define INCLUDE_TFSP_IHDR_H

#include "tfsp.h"
#include "tfs_errno.h"
#include "tfs_errlog.h"
#include "tfsp_spec.h"
#include "tfsp_common.h"
#include "tfsp_errno.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*------------------------------------------------------------------------------
  Define fixed values and macro
  ----------------------------------------------------------------------------*/
/**
 * ץ饰ѥեǥ쥯ȥ̾
 */
#define TFSP_PLUGIN_CONFIG_DIR	"conf"

/**
 * ץ饤١ȥƥȤޥ
 */
#define GET_PRIVATE_CTX(ctx)	((ctx)->d)

/*------------------------------------------------------------------------------
  Define structure/enum
  ----------------------------------------------------------------------------*/
typedef enum   tfsp_type_plugin	tfsp_type_plugin;
typedef struct tfsp_ihdr_base	tfsp_ihdr_base;
typedef struct tfsp_ctx_global	tfsp_ctx_global;
typedef struct tfsp_ctx_child	tfsp_ctx_child;
typedef struct tfsp_ihdr_abstract tfsp_ihdr_abstract;

/**
 * TeamFileץ饰μ
 */
enum tfsp_type_plugin {
	TFSP_PTYPE_UNKNOWN = 0,	/* (̤ʬ) */
	TFSP_PTYPE_CCIPHER,		/* (see tfsp_ihdr_ccipher.h) */
};

/**
 * TeamFileХץ饰١󥿡ե¤Τ
 */
struct tfsp_ihdr_base {
	/**
	 * ץ饰μ
	 */
	tfsp_type_plugin ptype;

	/**
	 * ץ饰̾
	 */
	const char *pname;

	/**
	 * ץ饰 󥿡ե
	 * [  ]
	 *   ץ饰饤֥꤬ǥ󥰤줿ľ˥뤵ޤ.
	 *   ǥ󥰸νХΰγѤƲ.
	 *
	 * (note)
	 *   ǥȤ줿Τϡθҥץfork() ǥԡ
	 *   ǽƼºݤѤޤ.
	 *   㤨Сեǥץ̵ѲǽǤ礦.Ǥ
	 *   ޥեʤɤϡҥץ(pinit) Ǥƥץ󤷤ʤФʤʤ
	 *   θʤФʤʤΤ⤢ޤ.
	 *   fork()  ˤäѤΤΤѤʤ̵Ǥ.
	 *   ɤƤȤȤǤСѤץ饰¦ǲ褷Ʋ.
	 *	
	 *	ʤºȤԤҥץФ褤ΤΤϡ
	 *	cinit 󥿡եǼ»ܤФ褤Ǥ礦.
	 *
	 * @param gctx tfsp_ctx_global * ץ饰󥰥Х륳ƥȤؤΥݥ
	 *             gctx ΥȤϸƤӽФǼ».
	 *             gctx->d NULLޤ. Ȥϥץ饰.
	 *             Ȥ줿ΰterminate ǳǤޤ.
	 * @param tfs_status_t ơ (see tfsp_errno.h)
	 */
	tfs_status_t (*init)(tfsp_ctx_global *gctx);

	/**
	 * ҥץΥץ饰 󥿡ե
	 * [  ]
	 *   ºȤԤҥץfork() ơ½Ԥľ˥뤵ޤ.
	 *   ҥץ˹Ԥץ饰νΰγѤƲ.
	 *
	 * @param cctx tfsp_ctx_child * ץ饰ҥץ٥륳ƥȤؤΥݥ
	 *             cctx ΥȤϸƤӽФǼ».
	 *             cctx->d NULLޤ.
	 *             cctx->global ˤ init ǽХ륳ƥǼ.
	 * @param tfs_status_t ơ (see tfsp_errno.h)
	 */
	tfs_status_t (*cinit)(tfsp_ctx_child *cctx);

	/**
	 * ҥץ˸ƤӽФץ饰λ 󥿡ե
	 *
	 * [  ]
	 *   ҥץλľ˥뤵ޤ.
	 *   ݤΰγʤɤѤƲ.
	 *
	 * (note) 顼ֵѤϤǤޤ. 顼ˤʤäƤⲿʤǤ.
	 *        顼ȯ褦ʼν϶ػߤޤ.
	 *
	 * @param cctx tfsp_ctx_child * cinitǽ줿ҥץ٥륳ƥȤؤΥݥ
	 */
	void (*cterminate)(tfsp_ctx_child *cctx);

	/**
	 * ץ饰λ 󥿡ե
	 * [  ]
	 *   ץ饰饤֥꤬unload ľ˥뤵ޤ.
	 *   ݤΰγʤɤѤƲ.
	 *
	 * (note) cterminate Ʊͥơ᤻ޤ
	 *
	 * @param gctx tfsp_ctx_global * init ǽ줿ƥȤؤΥݥ
	 */
	void (*terminate)(tfsp_ctx_global *gctx);

	/* ߡ. ץ饰Ф˿ʤ. */
	void *reserved1;
	void *reserved2;
	void *reserved3;
	void *reserved4;
	void *reserved5;
};

/**
 * ץ饰󥰥Х륳ƥȹ¤Τ
 *
 * [  ]
 *   * ץ饰ͭΥǡݻΰ
 */
struct tfsp_ctx_global {
	/* ץ饰󤬥󥹥ȡ뤵줿١ǥ쥯ȥΥѥ̾.
	 *
	 * [ ѥѥ ]
	 *   $plugin_root/$plugin_name
	 *   $plugin_root = $sdk_root/plugins
	 */
	const char *pluginpath;

	/* ġΥץ饰ѤΥեե֤Υѥ̾
	 *
	 * [ ѥѥ ]
	 *   (pluginpath ) / (TFSP_PLUGIN_CONFIG_DIR )
	 */
	const char *pluginconfdir;

	/* Х٥Υꥢ.
	 * ץ饰˻äƤޤ.
	 * init ϥɥľơterminate ľ˴ޤ. */
	tfs_pool_t *p;

	/**
	 * ǤդΥǡؤΥݥ (see GET_PRIVATE_CTX ޥ)
	 *
	 * ƥץ饰ϼʬȤɬפʥǡ򤳤ƻޤ魯Ȥޤ.
	 * SDKTeamFileΤϡΥФ򿨤뤳ȤϤޤ.
	 */
	void *d;

	/* ߡ. ץ饰Ф˿ʤ. */
	void *reserved1;
	void *reserved2;
	void *reserved3;
	void *reserved4;
	void *reserved5;
};

/**
 * ץ饰ҥץ٥륳ƥȹ¤Τ
 *
 * [  ]
 *   * ҥץñ̤ǻʤФʤʤǡݻΰ
 */
struct tfsp_ctx_child {
	/**
	 * init ǽ줿Х륳ƥȤؤΥݥ
	 */
	tfsp_ctx_global *global;

	/* Child٥Υꥢ.
	 * ץ饰˻äƤޤ.
	 * cinit ϥɥľơcterminate ľ˴ޤ. */
	tfs_pool_t *p;

	/**
	 * ǤդΥǡؤΥݥ (see GET_PRIVATE_CTX ޥ)
	 * ץ饰󤬾˻ȤäƲ. ʳ뤳ȤϤޤ.
	 */
	void *d;

	/* ߡ. ץ饰Ф˿ʤ. */
	void *reserved1;
	void *reserved2;
	void *reserved3;
	void *reserved4;
	void *reserved5;
};

/**
 * ƼΥץ饰˥㥹Ȥ뤿Ѥ빽¤
 * (note)
 *   ι¤ΤѤΤϥץ饰ΤߤǤ.
 *   Ƽץ饰Ѥι¤Τ򥭥㥹ȤŪѤ.
 */
struct tfsp_ihdr_abstract {
	const tfsp_ihdr_base *bs;
	void *dummy1;
	void *dummy2;
	void *dummy3;
};

/*------------------------------------------------------------------------------
  Declare public functions
  ----------------------------------------------------------------------------*/

#ifdef __cplusplus
}
#endif

#endif	/* INCLUDE_TFSP_IHDR_H */

