# $Id: config_vars.mk.in 2553 2008-01-24 07:24:33Z yone $
#-------------------------------------------------------------------------------
# Makefile for defined values
#-------------------------------------------------------------------------------

#--------------------------------------
# Define values of other programs
#--------------------------------------
CC = gcc
MAKE = gmake
LIBTOOL = /usr/bin/libtool --silent
INSTALL = install
RM = /bin/rm
AWK = awk
MV = /bin/mv

#--------------------------------------
# Define values for SDK
#--------------------------------------
PREFIX = /usr/local/teamfile/tfsplugin
SDKDIR = $(PREFIX)
SDKBINDIR     = $(SDKDIR)/bin 
SDKLIBDIR     = $(SDKDIR)/lib
SDKLIBPLDIR   = $(SDKDIR)/lib/perl
SDKINCLUDEDIR = $(SDKDIR)/include
PLUGINBASEDIR = $(SDKDIR)/plugins
BUILDDIR      = $(SDKDIR)/build
APACHE_DIR    = /usr/local/teamfile/www
TF_BINDIR     = $(APACHE_DIR)/bin
TF_JOBSDIR    = $(TF_BINDIR)/jobs
EXT = slo
DEPS = .deps

#--------------------------------------
# Define compile and link flags
#--------------------------------------
DEFAULT_CFLAGS = -g -pthread -Wall -Wno-long-long -Wcast-align -Wstrict-prototypes -fno-strict-aliasing
DEFAULT_CPPFLAGS = -DLINUX=2 -D_REENTRANT -D_XOPEN_SOURCE=500 -D_BSD_SOURCE -D_SVID_SOURCE -D_GNU_SOURCE -DAP_HAVE_DESIGNATED_INITIALIZER -DPACKAGE_NAME=\"\" -DPACKAGE_TARNAME=\"\" -DPACKAGE_VERSION=\"\" -DPACKAGE_STRING=\"\" -DPACKAGE_BUGREPORT=\"\"

