# $Id: tfs_rules.mk 971 2005-12-16 02:31:24Z takehara $
#-------------------------------------------------------------------------------
# TeamFileХץ饰SDKѶ Makefile
#
#-------------------------------------------------------------------------------
# SDK饤֥ڤӥġϤMakefile ɬinclude 뤳.
# ץ饰include Բ.
#
# ġMakefile ǽѿ
# ============================================
#   PROGRAM      : ӥɡ󥹥ȡ륿åȥ饤֥ (MUST)
#	SDKDIR       : ץ饰SDKΥȥåץǥ쥯ȥѥ (MUST)
#	(Ĥrules.mk )
#
# ġMakefile Ǻǽʤ륿å
# ============================================
#	INSTALL_TARGETS   : make install Υå (MUST)
#	UNINSTALL_TARGETS : make uninstall Υå (MUST)
#
#-------------------------------------------------------------------------------
# default target
all: all-local

# include common makefile
include $(SDKDIR)/build/rules.mk

#--------------------------------------
# Define values for plugin
#--------------------------------------
STOBJS = $(PROGRAM:.la=.a)
SOOBJS = $(PROGRAM:.la=.so)

#--------------------------------------
# Build target
#--------------------------------------
all-local: x-all $(PROGRAM)

#--------------------------------------
# install target
#--------------------------------------
install: all $(INSTALL_TARGETS)

install-library:
	@if test ! -d $(DESTDIR)$(SDKLIBDIR); then \
		$(INSTALL) -m 755 -d $(DESTDIR)$(SDKLIBDIR) ; \
	fi ; \
	$(LIBTOOL) --mode=install cp $(PROGRAM) $(DESTDIR)$(SDKLIBDIR) ; \
	cat $(DESTDIR)$(SDKLIBDIR)/$(PROGRAM) | \
		sed -e 's:-L[\/a-zA-Z0-9_\.$$-][\/a-zA-Z0-9_\.$\-]*\.libs:-L$(SDKLIBDIR):' \
		    -e 's:-L[\/a-zA-Z0-9_\.$$-][\/a-zA-Z0-9_\.$\-]*\.libs::g' \
		> $(DESTDIR)$(SDKLIBDIR)/$(PROGRAM).tmp && \
	$(MV) $(DESTDIR)$(SDKLIBDIR)/$(PROGRAM).tmp $(DESTDIR)$(SDKLIBDIR)/$(PROGRAM) ; \
	$(RM) -f $(DESTDIR)$(SDKLIBDIR)/$(STOBJS)

install-execution:
	@if test ! -d $(DESTDIR)$(SDKBINDIR); then \
		$(INSTALL) -m 755 -d $(DESTDIR)$(SDKBINDIR) ; \
	fi ; \
	$(LIBTOOL) --mode=install cp $(PROGRAM) $(DESTDIR)$(SDKBINDIR)

#--------------------------------------
# uninstall library
#--------------------------------------
uninstall: $(UNINSTALL_TARGETS)

uninstall-library:
	@if test -f $(DESTDIR)$(SDKLIBDIR)/$(PROGRAM); then \
		 $(LIBTOOL) --mode=uninstall $(RM) $(DESTDIR)$(SDKLIBDIR)/$(PROGRAM); \
	fi

uninstall-execution:
	@if test -f $(DESTDIR)$(SDKBINDIR)/$(PROGRAM); then \
		rm -f $(DESTDIR)$(SDKBINDIR)/$(PROGRAM) ; \
	fi

.PHONY: all all-local install install-library \
		uninstall uninstall-library install-execution uninstall-execution

